art - Bug #24427

Message of exception ProductNotFound lacking information
05/17/2020 12:43 AM - Gianluca Petrillo

Status: Closed Start date: 05/16/2020
Priority: Normal Due date:

Assignee: Kyle Knoepfel % Done: 100%
Category: Infrastructure Estimated time: 4.00 hours
Target version: 3.06.00 Spent time: 4.00 hours
Occurs In: Experiment: -

Scope: Internal SSI Package:

Description

| recall the message for a missing data product from art::Event::getByLabel() and art::Event::getValid() being more descriptive than
what | seem to get now:

———— ProductNotFound BEGIN
getBySelector: Found zero products matching all criteria
Looking for type: std::vector<simb::MCParticle>
The above exception was thrown while processing module DumpMCParticles/dumpmcparticles run
1 subRun: 0 event: 1
———— ProductNotFound END

considering that the query was given a art::InputTag.
Is it possible to have an error message including all the constraints of the query, including the input tag?

To reproduce it, with LArSoft:

source /cvmfs/larsoft.opensciencegrid.org/products/setup
setup larsoft v08_52_00 —-g el9:prof

lar -c empty_events.fcl -o Empty.root -n 1

lar -c dump_mcparticles.fcl -s Empty.root

which shows me:
16-May—-2020 19:23:40 CDT 1Initiating request to open input file "Empty.root"
16-May-2020 19:23:41 CDT Opened input file "Empty.root"

16-May-2020 19:23:41 CDT Closed input file "Empty.root"

TrigReport —-——-—-——-—- Event Summary —-———-—-—-—--———-
TrigReport Events total = 1 passed = 1 failed = 0

TrigReport —-————- Modules in End-Path: end _path - —————————-
TrigReport Trig Bit# Run Success Error Name

TrigReport 0 0 1 0 1 dumpmcparticles
TimeReport —-————————-— Time Summary —---[sec]--——-—

TimeReport CPU = 0.004033 Real = 0.004351

MemReport —————————-— Memory Summary —---[base-10 MB]--———
MemReport VmPeak = 513.806 VmHWM = 120.775

$MSG-s ArtException: PostEndJob 16-May-2020 19:23:41 CDT ModuleEndJob
—-——— EventProcessorFailure BEGIN
EventProcessor: an exception occurred during current event processing
—-——— EventProcessorFailure BEGIN
EndPathExecutor: an exception occurred during current event processing
———— ScheduleExecutionFailure BEGIN
Path: ProcessingStopped.
———— ProductNotFound BEGIN
getBySelector: Found zero products matching all criteria
Looking for type: std::vector<simb::MCParticle>
The above exception was thrown while processing module DumpMCParticles/dumpmcparticles run
1 subRun: 0 event: 1
———— ProductNotFound END
Exception going through path end_path
———— ScheduleExecutionFailure END
———— EventProcessorFailure END
—-———- EventProcessorFailure END
TMSG
Art has completed and will exit with status 1.

(the configured input tag in the example is the always fashionable largeant).

History

#1 - 05/18/2020 10:24 AM - Kyle Knoepfel
- Estimated time set to 4.00 h

- Status changed from New to Assigned

We'll take a look.

#2 - 05/18/2020 10:24 AM - Kyle Knoepfel

- Assignee set to Kyle Knoepfel

#3 - 06/01/2020 08:14 AM - Kyle Knoepfel

The problem is understood. It appears that during some cleanup, the extra diagnostic information was removed. We will restore it.

#4 - 06/02/2020 08:45 AM - Kyle Knoepfel

- % Done changed from 0 to 100

- Target version set to 3.06.00

- Status changed from Assigned to Resolved

- Category set to Infrastructure

Fixed with commits:

e art:060e656
e art:6d6dbc8

The fix does require a change in the interface of art::SelectorBase, so this is technically a breaking change, and will be documented on the
breaking-changes page for art 3.06.

#5 - 07/10/2020 01:58 PM - Kyle Knoepfel

- Status changed from Resolved to Closed
https://cdcvs.fnal.gov/redmine/projects/art/repository/revisions/060e6569fcbf3d40bc0fefe0a85e6122743d991a
https://cdcvs.fnal.gov/redmine/projects/art/repository/revisions/6d6dbc88bec17b083e8f0aa4dcc5637fa04e8a89
